# Deep Blue

Deep Blue was a legendary [chess](chess.md) playing [IBM](ibm.md) [supercomputer](supercomputer.md), which in 1997 made [history](history.md) by being the first ever [computer](computer.md) to beat the human world chess champion at the time (Garry Kasparov), marking a moment which many consider that at which "computers finally outsmarted humans". Since then computers really did continue to surpass humans at chess by much greater margins; nowadays a mere cellphone running [stockfish](stockfish.md) can easily rape the world chess champion.

History: it all started around 1985 as a program called ChipTest by some Taiwanese guy with unpronounceable name. It went on to win some computer chess tournaments and when multiple people were already working on it as a part of IBM research, it was renamed to Deep Thought after the computer in [Hitchhiker's Guide to the Galaxy](hgttg.md), however **it had to be later renamed to Deep Blue because the name too much resembled [deep throat](deep_throat.md)** :D By 1990 it has already played the world champion, Kasparov, but lost. In 1996 Deep Blue played him again, this time losing the match again but already having won a game, showing the potential was there. In May 1997, after upgrade both in hardware and software, it finally beat Kasparov with 3 wins, 2 losses and 1 draw.

{ Lol, according to Wikipedoa it trolled Kasparov in the first game by making a completely random move due to a bug once, it scared him because he thought it was some deeply calculated threat while it was just some completely dumb move. ~drummyfish }

It's important to see that Deep Blue wasn't really a general chess engine like [stockfish](stockfish.md), it was a single purpose supercomputer, a combination of [hardware](hw.md) and [software](sw.md) engineered from the ground up with the single purpose: win the match against Garry Kasparov. It was being fine tuned in between the games with assistance of grandmasters. A team of experts on computers and chess focused their efforts on this single opponent at the specific time controls and match set up, rather than trying to make a generally usable chess computer. They studied Kasparov's play and made Deep Blue ready for it; they even employed psychological tricks -- for example it had preprogrammed instant responses to some Kasparov's expected moves, so as to make him more nervous.

Technical details: Deep Blue was mainly relying on massively parallel [brute force](brute_force.md), i.e. looking many moves ahead and consulting stored databases of games; in 1997 it had some 11 [GFLOPS](flops.md). The base computer was IBM RS/6000 SP (taking two cabinets) with IBM AIX [operating system](operating_system.md), using 32 [PowerPC](ppc.md) 200 MHz processors and 480 specialized "chess chips". It had evaluation function implemented in hardware. All in all the whole system could search hundreds of millions positions per second. Non-extended search was performed to a depth of about 12 plies, extended search went even over 40 plies deep. It had an opening book with about 4000 positions and endgame tablebases for up to 6 pieces. It was programmed in [C](c.md). { Sources seems to sometimes give different numbers and specs, so not exactly sure about this. ~drummyfish }

## See Also

- [stockfish](stockfish.md)
